use clay_layout::{
    Clay, Declaration, grow,
    layout::{LayoutDirection, Padding},
    render_commands::RenderCommand,
};
use document::Document;

mod document;

pub struct GUI {
    pub document: Document,
}

impl GUI {
    pub fn new() -> Self {
        Self {
            document: Document::new(),
        }
    }

    pub fn render<'a>(
        &'a mut self,
        clay: &'a Clay,
        left_mouse: (bool, bool),
        right_mouse: (bool, bool),
        latest_char: (Option<char>, Option<u32>),
        time: f64,
    ) -> impl Iterator<Item = RenderCommand> {
        clay.begin();

        self.document
            .render(clay, left_mouse, right_mouse, latest_char, time);

        clay.end()
    }
}
